--[[ winterbeach.lua
Created by: birbhorse, aka EeveeEuphoria
Credits:
	- Ice Spring, Rock Shield, Mobj RingSpill: Me, since I made those.
	- Music: https://soundcloud.com/leila-wilson-woofle/312notaiz
		Act 2: https://music.ubiktune.com/track/taiga
	- Sonic the Hedgehog (Master System) - Sound and Sprites used for the broken ring monitor.
	- Pokemon X/Y - The Pi(ka)chu.

]]

--[[ 

todo:
- make seasonal rings work with magnet/electric shield 
- commission someone to sprite the winter scenery, and the summer/winter rings (winter rings has icicles, summer rings...idk, radiate sun rays?)

bugs:
- ice rings/sum rings get triggered early if loading in from the menu (most likely fixed)
- montiors do not properly switch weather, it changes seasons but not weather (only happens in the anti-crawla cave, at the end section)
- tails bot does not interact properly with seasonal rings; no noise is made 

todo: 
- reset regular rings state when seasons changes, just so it can sync with the seasonal rings
- make seperate value to subtract the sum/ice rings from 

]]

local winterbeachteleport
local season = "summer"
local previousseason = "winter"
local spawnedspring
local maploaded = false

local sumrings = 0
local icerings = 0
local sumringconfirm = false
local iceringconfirm = false

freeslot(
"SPR_RADI",
"SPR_RAD2",
"S_RADIOSON",
"MT_RADIO",

"SPR_WBHO",
"S_HOLOGRAMSNOW",
"S_HOLOGRAMSUMMER",
"MT_WBHOLOGRAM",

"MT_WBWING",
"S_WBWING",
"S_WBWINGNO",

"S_SEASON_BOX",
"S_SEASON_GOLDBOX",
"S_SEASON_ICON1",
"S_SEASON_ICON2",

"MT_SEASON_ICON",
"MT_SEASON_BOX",
"MT_SEASON_GOLDBOX",

"SPR_TVWM",

"SPR_WBSC",
"MT_WBSECRET",
"S_SECRETWB",

"SPR_WBS2",
"MT_WBSECRET2",
"S_SECRETWB2",

"MT_NOCRAWLA",
"SPR_WBSG",
"S_NO_CRAWLA_SIGN",

"MT_ICESPRING", "SPR_ISRG", "S_ICESPRING", "S_ICESPRING2", "S_ICESPRING3", "S_ICESPRING4", "S_ICESPRING5", "S_ICESPRING6", "S_ICESPRING7", "S_ICESPRING8", 
"sfx_smwins", "MT_ICESHRAPNEL", "S_ICESHRAP", "S_ICESHRAP2", "S_ICESHRAP3", "S_ICESHRAP4", "SPR_ISHR",

"SPR_WBT1", "S_XMASGFZTREE",
"SPR_WBPK", "S_XMASPINETREE",

"sfx_sttb3",
"sfx_sttc7"

)

states[S_XMASGFZTREE] = {SPR_WBT1, 0, -1, nil, 0, 0, S_NULL}

states[S_XMASPINETREE] = {SPR_WBPI, 0, -1, nil, 0, 0, S_NULL}


states[S_RADIOSON] = {
	sprite = SPR_RADI,
	frame = A,
	tics = -1,
}

states[S_NO_CRAWLA_SIGN] = {
	sprite = SPR_WBSG,
	frame = FF_PAPERSPRITE,
	tics = -1,
}

states[S_HOLOGRAMSNOW] = {
	sprite = SPR_WBHO,
	frame = FF_PAPERSPRITE|A,
	tics = -1,
}

states[S_HOLOGRAMSUMMER] = {
	sprite = SPR_WBHO,
	frame = FF_PAPERSPRITE|B,
	tics = -1,
}

states[S_WBWING] = {
	sprite = SPR_TRNG,
	frame = A|FF_ANIMATE,
	tics = -1,
	var1 = 23,
	var2 = 1,
	nextstate = S_WBWING
}

states[S_WBWINGNO] = {
	sprite = SPR_TRNG,
	frame = A|FF_ANIMATE|TR_TRANS40,
	tics = -1,
	var1 = 23,
	var2 = 1,
	nextstate = S_WBWINGNO
}

mobjinfo[MT_RADIO] = {
	--$Name Radio
	--$Sprite RADIA0
	--$Category winterbeach Objects
	doomednum = 669,
	spawnstate = S_RADIOSON,
	speed = 0,
	height = 15*FRACUNIT,
	radius = 20*FRACUNIT,
	dispoffset = 0,
	flags = MF_NOGRAVITY|MF_NOBLOCKMAP|MF_NOCLIP
}

mobjinfo[MT_WBHOLOGRAM] = {
	--$Name Season Hologram
	--$Sprite WBHOA0
	--$Category winterbeach Objects
	doomednum = 670,
	spawnstate = S_HOLOGRAMSNOW,
	speed = 0,
	height = 128*FRACUNIT,
	radius = 40*FRACUNIT,
	dispoffset = 0,
	flags = MF_NOGRAVITY|MF_NOBLOCKMAP|MF_NOCLIP
}

mobjinfo[MT_WBWING] = {
	--$Name Seasonal Ring
	--$Sprite TRNGA0
	--$Category winterbeach Objects
	doomednum = 671,
	spawnhealth = 1000,
	spawnstate = S_WBWING,
	deathstate = S_SPRK1,
	deathsound = sfx_itemup,
	speed = 38*FRACUNIT,
	radius = 16*FRACUNIT,
	height = 24*FRACUNIT,
	mass = 100,
	flags = MF_SLIDEME|MF_SPECIAL|MF_NOGRAVITY|MF_NOCLIPHEIGHT
}

mobjinfo[MT_NOCRAWLA] = {
	--$Name No Crawlas Sign 
	--$Sprite WBSGAR
	--$Category winterbeach Objects
	doomednum = 3021,
	spawnhealth = 1000,
	spawnstate = S_NO_CRAWLA_SIGN,
	radius = 22*FRACUNIT,
	height = 64*FRACUNIT,
	mass = 100,
	flags = MF_SOLID|MF_PAPERCOLLISION|MF_SCENERY
}


local function A_ChangeSeasons(actor, var1, var2)
	if season == "summer"
		P_LinedefExecute(25)
	else
		P_LinedefExecute(39)
	end
end

states[S_SEASON_BOX] = {SPR_TVWM, 0, 2, nil, 0, 0, S_BOX_FLICKER}
states[S_SEASON_GOLDBOX] = {SPR_TVWM, 1, 2, A_GoldMonitorSparkle, 0, 0, S_GOLDBOX_FLICKER}

states[S_SEASON_ICON1] = {SPR_TVWM, FF_ANIMATE|2, 18, nil, 3, 4, S_SEASON_ICON2}
states[S_SEASON_ICON2] = {SPR_TVWM, 2, 18, A_ChangeSeasons, 0, 0, S_NULL}

mobjinfo[MT_SEASON_BOX] = {
		--$Name Season Monitor
		--$Sprite TVWMA0
		--$Category winterbeach Objects
		
		doomednum = 3009,
		spawnstate = S_SEASON_BOX,
		spawnhealth = 1,
		seestate = S_NULL,
		seesound = sfx_None,
		reactiontime = 8,
		attacksound = sfx_None,
		painstate = S_SEASON_BOX,
		painchance = 0,
		painsound = sfx_None,
		meleestate = S_NULL,
		missilestate = S_NULL,
		deathstate = S_BOX_POP1,
		xdeathstate = S_NULL,
		deathsound = sfx_pop,
		speed = 1,
		radius = 18*FRACUNIT,
		height = 40*FRACUNIT,
		dispoffset = 0,
		mass = 100,
		damage = MT_SEASON_ICON,
		activesound = sfx_None,
		flags  = MF_SOLID|MF_SHOOTABLE|MF_MONITOR,
		raisestate = S_NULL
	}
	
	mobjinfo[MT_SEASON_GOLDBOX] = {
		--$Name Season Monitor (Respawning)
		--$Sprite TVWMB0
		--$Category winterbeach Objects
		
		doomednum = 3010,
		spawnstate = S_SEASON_GOLDBOX,
		spawnhealth = 1,
		seestate = S_NULL,
		seesound = sfx_None,
		reactiontime = 8,
		attacksound = sfx_monton,
		painstate = S_SEASON_GOLDBOX,
		painchance = 0,
		painsound = sfx_None,
		meleestate = S_NULL,
		missilestate = S_NULL,
		deathstate = S_GOLDBOX_OFF1,
		xdeathstate = S_NULL,
		deathsound = sfx_pop,
		speed = 1,
		radius = 18*FRACUNIT,
		height = 40*FRACUNIT,
		dispoffset = 0,
		mass = 100,
		damage = MT_SEASON_ICON,
		activesound = sfx_None,
		flags  = MF_SOLID|MF_SHOOTABLE|MF_MONITOR,
		raisestate = S_NULL
	}
	
mobjinfo[MT_SEASON_ICON] = {
		doomednum = -1,
		spawnstate = S_SEASON_ICON1,
		spawnhealth = 1,
		seestate = S_NULL,
		seesound = sfx_s3k6e,
		reactiontime = 8,
		attacksound = sfx_None,
		painstate = S_NULL,
		painchance = 0,
		painsound = sfx_None,
		meleestate = S_NULL,
		missilestate = S_NULL,
		deathstate = S_NULL,
		xdeathstate = S_NULL,
		deathsound= sfx_None,
		speed = 2*FRACUNIT,
		radius = 8*FRACUNIT,
		height = 14*FRACUNIT,
		dispoffset = 0,
		mass = 100,
		damage = 62*FRACUNIT,
		activesound = sfx_None,
		flags = MF_NOBLOCKMAP|MF_NOCLIP|MF_SCENERY|MF_NOGRAVITY|MF_BOXICON,
		raisestate = S_NULL
	}

states[S_SECRETWB] = {
	sprite = SPR_WBSC,
	frame = A|FF_ANIMATE,
	tics = -1,
	var1 = 46,
	var2 = 1,
	nextstate = S_SECRETWB
}

states[S_SECRETWB2] = {
	sprite = SPR_WBPK,
	frame = A|FF_ANIMATE,
	tics = -1,
	var1 = 32,
	var2 = 1,
	nextstate = S_SECRETWB2
}

mobjinfo[MT_WBSECRET] = {
		--$Name Pichu
		--$Sprite WBSCA0
		--$Category winterbeach Objects
	doomednum = 672,
	spawnstate = S_SECRETWB,
	speed = 0,
	height = 15*FRACUNIT,
	radius = 20*FRACUNIT,
	dispoffset = 0,
	flags = MF_NOGRAVITY|MF_NOBLOCKMAP|MF_NOCLIP
}

mobjinfo[MT_WBSECRET2] = {
		--$Name Pikachu
		--$Sprite WBPKA0
		--$Category winterbeach Objects
	doomednum = 674,
	spawnstate = S_SECRETWB2,
	speed = 0,
	height = 15*FRACUNIT,
	radius = 20*FRACUNIT,
	dispoffset = 0,
	flags = MF_NOGRAVITY|MF_NOBLOCKMAP|MF_NOCLIP
}

addHook("MapLoad", function(map) if gamemap != 43 return end 

	winterbeachteleport = false
	season = "summer"
	previousseason = "summer"
	spawnedspring = false
	
end)

addHook("MapChange", function(map) if gamemap != 43 return end 

	icerings = 0
	sumrings = 0
	sumringconfirm = false
	iceringconfirm = false
	
end)

addHook("LinedefExecute", function(buttonsmash, mo) if gamemap != 43 return end --local player = mo.player
	winterbeachteleport = true
	season = "winter"
	--print("ACTIVATED THE BUPPON")
	if season != previousseason
		S_StartSound(mo, sfx_s3k76)	
		for mapthing in mapthings.iterate do
			if mapthing.type == mobjinfo[MT_WBWING].doomednum
				mapthing.mobj.ChangeSelf = true
			end
		end
	end
	
	--print(sumrings)
	--print(icerings)
	
end, "BTNMSH")

addHook("LinedefExecute", function(buttonsmash, mo) if gamemap != 43 return end --local player = mo.player
	winterbeachteleport = true
	season = "summer"
	--print("SUMMER TIME AGAIN")
	if season != previousseason
		S_StartSound(mo, sfx_s3k76)
		for mapthing in mapthings.iterate do
			if mapthing.type == mobjinfo[MT_WBWING].doomednum
				mapthing.mobj.ChangeSelf = true
			elseif mapthing.type == mobjinfo[MT_ICESPRING].doomednum
				mapthing.mobj.Ready = true
			end
		end
	end
	
	--print(sumrings)
	--print(icerings)
	
end, "BTNSUM")

addHook("MapThingSpawn", function(ring, mapthing) if gamemap != 43 return end
	if mapthing.options & MTF_AMBUSH
		ring.z = $ + (24*FRACUNIT)
	end
	
	ring.timer = 0 
	
	if mapthing.options & MTF_EXTRA
		ring.winter = true
	else
		ring.summer = true
	end
	
end, MT_WBWING)


addHook("MapThingSpawn", function(sign, mapthing) if gamemap != 43 return end
	if mapthing.options & MTF_AMBUSH
		sign.frame = B|FF_PAPERSPRITE
	end
	
	if mapthing.options & MTF_EXTRA
		sign.frame = C|FF_PAPERSPRITE
	end
	
end, MT_NOCRAWLA)

addHook("ThinkFrame", function(buppon) if gamemap != 43 return end

	if leveltime > 10*TICRATE
		maploaded = true -- i know i should just do this directly, but shut up this was from older code and i'm lazy
	end

	if winterbeachteleport and season != previousseason
		--print("lol horses")
		if season == "winter"
		
			for sector in sectors.iterate do 
				if sector.floorpic == "GFZFLR02"
					sector.floorpic = "SNOW01"
				elseif sector.floorpic == "GFZFLR21"
					sector.floorpic = "SNWFLR"
				elseif sector.floorpic == "CHKGRASF"
					sector.floorpic = "SNWCHK"				
				elseif sector.floorpic == "DPSAND"
					sector.floorpic = "WBSAND"				
				elseif sector.floorpic == "SANDWLL"
					sector.floorpic = "SANDWBL"
				end
				
				if sector.ceilingpic == "GFZFLR02"
					sector.ceilingpic = "SNOW01"
				elseif sector.ceilingpic == "GFZFLR21"
					sector.ceilingpic = "SNWFLR"
				elseif sector.ceilingpic == "CHKGRASF"
					sector.ceilingpic = "SNWCHK"				
				elseif sector.ceilingpic == "DPSAND"
					sector.ceilingpic = "WBSAND"				
				elseif sector.ceilingpic == "SANDWLL"
					sector.ceilingpic = "SANDWBL"
				end
			end
			
			if not spawnedspring
				--print("i summon thee, spring")
				P_SpawnMobj(12112*FRACUNIT, 22840*FRACUNIT, 168*FRACUNIT, MT_YELLOWSPRING)
				spawnedspring = true
			end
			
			for mapthing in mapthings.iterate do -- ice emblem
				if mapthing.type == mobjinfo[MT_EMBLEM].doomednum
					if mapthing.angle == 10 and mapthing.mobj
						mapthing.mobj.z = 624*FRACUNIT
					end
				end
			end
		
		else
			for sector in sectors.iterate do 
				if sector.floorpic == "SNOW01"
					sector.floorpic = "GFZFLR02"
				elseif sector.floorpic == "SNWFLR"
					sector.floorpic = "GFZFLR21"
				elseif sector.floorpic == "SNWCHK"
					sector.floorpic = "CHKGRASF"
				elseif sector.floorpic == "WBSAND"
					sector.floorpic = "DPSAND"
				elseif sector.floorpic == "SANDWBL"
					sector.floorpic = "SANDWLL"
				end
				if sector.ceilingpic == "SNOW01"
					sector.ceilingpic = "GFZFLR02"
				elseif sector.ceilingpic == "SNWFLR"
					sector.ceilingpic = "GFZFLR21"
				elseif sector.ceilingpic == "SNWCHK"
					sector.ceilingpic = "CHKGRASF"
				elseif sector.ceilingpic == "WBSAND"
					sector.ceilingpic = "DPSAND"
				elseif sector.ceilingpic == "SANDWBL"
					sector.ceilingpic = "SANDWLL"
				end
			end
			
			
			for mapthing in mapthings.iterate do -- ice emblem
				if mapthing.type == mobjinfo[MT_EMBLEM].doomednum
					if mapthing.angle == 10 and mapthing.mobj
						mapthing.mobj.z = 496*FRACUNIT
					end
				end
			end
			
		end
		winterbeachteleport = false
		previousseason = season
		for player in players.iterate do
			P_FlashPal(player, PAL_WHITE, (TICRATE/3))
		end
	end
	
	if maploaded -- just to make sure these don't get set off before the values have actually been set 
		if icerings == 0 and not iceringconfirm
			--print("ice crab")
			iceringconfirm = true
			P_LinedefExecute(107) -- lowers platform at the start of the level
			P_LinedefExecute(140) -- raises platform to give emblem
			for mapthing in mapthings.iterate do
				if mapthing.type == mobjinfo[MT_EMBLEM].doomednum
					if mapthing.angle == 2 and mapthing.mobj
						mapthing.mobj.z = 192*FRACUNIT
						--print("changed z for ice")
					end
				end
			end
			
			
			-- MAKE HUD THAT SHOWS UP FOR A FEW SECONDS, NOTIFYING PLAYER OF ACCOMPLISHMENT
		end
		
		if sumrings == 0 and not sumringconfirm
			--print("crab")
			P_LinedefExecute(143) -- raises platform to give emblem
			sumringconfirm = true
			for mapthing in mapthings.iterate do
				if mapthing.type == mobjinfo[MT_EMBLEM].doomednum
					if mapthing.angle == 1 and mapthing.mobj
						mapthing.mobj.z = 192*FRACUNIT
						--print("changed z for sum")
					end
				end
			end
		end
	end
	
end)

addHook("MobjThinker", function(radio) if radio.setscale and radio.setsprite return end
	if not radio.setscale
		radio.scale = FRACUNIT/3
		radio.setscale = true
	end
	
	if not radio.setsprite 
		if radio.angle > ANG15
			radio.sprite = SPR_RAD2
		end
		radio.setsprite = true
	end
	
	if radio.setscale and radio.setsprite
		radio.flags = MF_SCENERY
	end

end, MT_RADIO)

addHook("MobjThinker", function(hologram) -- have this pulsate it's transparency, from 30 to 60
	if not hologram.setsprite 
		if hologram.angle > ANG15
			hologram.state = S_HOLOGRAMSUMMER
		end
		hologram.angle = 0
		hologram.setsprite = true
	end
	
	if hologram.state == S_HOLOGRAMSNOW
		if season == "summer"
			hologram.angle = $ + FixedAngle(5<<FRACBITS)
		else
			hologram.angle = $ + ANG2
		end
	else
		if season == "winter"
			hologram.angle = $ + FixedAngle(5<<FRACBITS)
		else
			hologram.angle = $ + ANG2
		end
	end

end, MT_WBHOLOGRAM)



local function winteriscoming(mobj) if gamemap != 43 return end
	if season == "winter"
		S_StopSound(mobj)
		return true
	else
		return false
	end
end

local function iammelting(mobj) if gamemap != 43 return end
	if season == "summer"
		mobj.state = S_INVISIBLE
		return true
	else
		mobj.state = mobj.info.spawnstate
		return false
	end
end

local function iamexploding(mobj) if gamemap != 43 return end

	if mobj.timer == nil
		mobj.timerz = 0
		mobj.respawn = true
	end
	
	if season == "summer" and mobj.state != S_INVISIBLE
		mobj.state = S_INVISIBLE
		S_StartSound(mobj, sfx_smwins)
	end

	if mobj.state == S_INVISIBLE
		if not mobj.SpawnedThem
			mobj.flags = MF_NOGRAVITY
			local piece1 = P_SpawnMobj(mobj.x, mobj.y, mobj.z, MT_ICESHRAPNEL)
			local piece2 = P_SpawnMobj(mobj.x, mobj.y, mobj.z, MT_ICESHRAPNEL)
			local piece3 = P_SpawnMobj(mobj.x, mobj.y, mobj.z, MT_ICESHRAPNEL)
			local piece4 = P_SpawnMobj(mobj.x, mobj.y, mobj.z, MT_ICESHRAPNEL)			
			local piece5 = P_SpawnMobj(mobj.x, mobj.y, mobj.z, MT_ICESHRAPNEL)
			local piece6 = P_SpawnMobj(mobj.x, mobj.y, mobj.z, MT_ICESHRAPNEL)
			local piece7 = P_SpawnMobj(mobj.x, mobj.y, mobj.z, MT_ICESHRAPNEL)
			local piece8 = P_SpawnMobj(mobj.x, mobj.y, mobj.z, MT_ICESHRAPNEL)
			piece1.number = 1
			piece2.number = 2
			piece3.number = 3
			piece4.number = 4
			piece5.number = 1
			piece6.number = 2
			piece7.number = 3
			piece8.number = 4
			piece1.angle = mobj.angle + (ANG1 * (P_RandomRange(-360, 360)))
			piece2.angle = mobj.angle + (ANG1 * (P_RandomRange(-360, 360)))
			piece3.angle = mobj.angle + (ANG1 * (P_RandomRange(-360, 360)))
			piece4.angle = mobj.angle + (ANG1 * (P_RandomRange(-360, 360)))			
			piece5.angle = mobj.angle + (ANG1 * (P_RandomRange(-360, 360)))
			piece6.angle = mobj.angle + (ANG1 * (P_RandomRange(-360, 360)))
			piece7.angle = mobj.angle + (ANG1 * (P_RandomRange(-360, 360)))
			piece8.angle = mobj.angle + (ANG1 * (P_RandomRange(-360, 360)))
			A_MobjRingBurst(mobj, 10) -- just for fun 
			mobj.SpawnedThem = true
		end
		
		mobj.Ready = true
		
		if mobj.Ready and season == "winter"
			mobj.state = mobj.info.spawnstate
			mobj.flags = mobj.info.flags
			mobj.timerz = 0
			mobj.SpawnedThem = false
			mobj.Ready = false
			--print("change back")
		end
	end
end

local function snowcovered(mobj) if gamemap != 43 return end
	if season == "winter" and not mobj.changedtype
		if mobj.type == MT_BUSH 
			mobj.state = S_XMASBUSH
		elseif mobj.type == MT_BERRYBUSH 
			mobj.state = S_XMASBERRYBUSH
		elseif mobj.type == MT_BLUEBERRYBUSH
			mobj.state = S_XMASBLUEBERRYBUSH
		elseif mobj.type == MT_GFZTREE
			mobj.state = S_XMASGFZTREE		
		elseif mobj.type == MT_PINETREE
			mobj.state = S_XMASPINETREE
		end
		mobj.changedtype = true
		return true
	elseif season == "summer" and mobj.changedtype
		mobj.state = mobj.info.spawnstate
		mobj.changedtype = false
		return false
	end

end

local function Smart(mapthing) -- doesn't work :(
	mapthing.flags = $ & ~MF_NOTHINK
end

addHook("MobjThinker", snowcovered, MT_BUSH)
addHook("MobjThinker", snowcovered, MT_BLUEBERRYBUSH)
addHook("MobjThinker", snowcovered, MT_BERRYBUSH)
addHook("MobjThinker", snowcovered, MT_GFZTREE)
addHook("MobjThinker", snowcovered, MT_PINETREE)

addHook("MobjThinker", iammelting, MT_FHZICE1)
addHook("MobjThinker", iammelting, MT_FHZICE2)

addHook("MobjThinker", iamexploding, MT_SNOWMAN)
addHook("MobjThinker", iamexploding, MT_SNOWMANHAT)



addHook("MobjThinker", function(ring) if gamemap != 43 return end -- create internal timer used to reset frame to correct time, FF_ANIMATE|TR_TRANS40
	if not ring.shadowscale and ring.health
		ring.ChangeSelf = true
		ring.shadowscale = 2*FRACUNIT/3 
		if ring.summer
			ring.color = SKINCOLOR_APRICOT -- SKINCOLOR_ORANGE, YOGURT
			sumrings = $ + 1
		else
			ring.color = SKINCOLOR_ICY
			icerings = $ + 1	
		end
	end 
	
	--[[if winterbeachteleport --used to work, until i changed everything to use continous on the map
		ring.ChangeSelf = true
		--print("change")
	end]]
	
	
	if ring.ChangeSelf and (ring.state == S_WBWING or ring.state == S_WBWINGNO) and leveltime > TICRATE 
		if ring.winter and season == "summer"
			ring.state = S_WBWINGNO
		elseif ring.summer and season == "winter"
			ring.state = S_WBWINGNO
		elseif ring.state != S_WBWING
			ring.state = S_WBWING
		end
	ring.ChangeSelf = false
	end

end, MT_WBWING)


addHook("TouchSpecial", function(ring, playermobj) if gamemap != 43 return end
	if ring.state == S_WBWING
		P_GivePlayerRings(playermobj.player, 1)
		if ring.summer
			sumrings = $ - 1
		else
			icerings = $ - 1
		end
		if playermobj.player.bot == 0
			return false
		else
			P_KillMobj(ring)
			return true
		end
	else
		return true
	end
end, MT_WBWING)

addHook("MobjThinker", winteriscoming, MT_AWATERA)
addHook("MobjThinker", winteriscoming, MT_AWATERB)
addHook("MobjThinker", winteriscoming, MT_AWATERC)
addHook("MobjThinker", winteriscoming, MT_AWATERD)
addHook("MobjThinker", winteriscoming, MT_AWATERE)
addHook("MobjThinker", winteriscoming, MT_AWATERF)
addHook("MobjThinker", winteriscoming, MT_AWATERG)
addHook("MobjThinker", winteriscoming, MT_AWATERH)
addHook("MobjThinker", winteriscoming, MT_WATERDRIP)
addHook("MobjThinker", winteriscoming, MT_JETJAW) -- they make annoying sounds otherwise

-- MT_FHZICE1, MT_FHZICE2


mobjinfo[MT_ICESPRING] = {
		--$Name Ice Spring
		--$Sprite ISRGA0
		--$Category Springs and Fans
		
		doomednum = 3069,							-- REPLACE ME!!
		spawnstate = S_ICESPRING,
		seestate = S_ICESPRING2,
		seesound = sfx_None,
		attacksound = sfx_None,
		painstate = S_NULL,
		painsound = sfx_s1cc,
		meleestate = S_NULL,
		missilestate = S_NULL,
		deathstate = S_NULL,
		xdeathstate = S_NULL,
		deathsound = sfx_None,
		activesound = sfx_smwins,
		raisestate = S_ICESPRING2,
		spawnhealth = 1000,
		reactiontime = 0, -- undocumented, but changing this to 0 prevents it from giving points. why the hell isn't this documented?
		painchance = 7,							-- Respawn timer, in seconds
		speed = 0,
		radius = 20*FRACUNIT,
		height = 16*FRACUNIT,
		dispoffset = 0,
		mass = 17*FRACUNIT,							-- Used for the strength of the spring, for reference: Red (32), Yellow (20), Blue (11)
		damage = 0,
		flags = MF_SOLID|MF_SPRING
	}

mobjinfo[MT_ICESHRAPNEL] = {
	doomednum = -1,
	spawnstate = S_ICESHRAP,
	height = 5*FRACUNIT,
	radius = 5*FRACUNIT,
	flags = MF_BOUNCE|MF_NOCLIPTHING
}

states[S_ICESPRING] = {SPR_ISRG, A, -1, nil, 0, 0, S_NULL}
states[S_ICESPRING2] = {SPR_ISRG, B, 4, A_Pain, 0, 0, S_ICESPRING3}
states[S_ICESPRING3] = {SPR_ISRG, C, 2, nil, 0, 0, S_ICESPRING4}
states[S_ICESPRING4] = {SPR_ISRG, D, 2, nil, 0, 0, S_ICESPRING5}
states[S_ICESPRING5] = {SPR_ISRG, E, 2, nil, 0, 0, S_ICESPRING6}
states[S_ICESPRING6] = {SPR_ISRG, F, 2, nil, 0, 0, S_ICESPRING7}
states[S_ICESPRING7] = {SPR_ISRG, G, 2, nil, 0, 0, S_ICESPRING8}
states[S_ICESPRING8] = {SPR_ISRG, H, 2, A_PlayActiveSound, 0, 0, S_INVISIBLE}

states[S_ICESHRAP] = {SPR_ISHR, A, -1, nil, 0, 0, S_NULL}
states[S_ICESHRAP2] = {SPR_ISHR, B, -1, nil, 0, 0, S_NULL}
states[S_ICESHRAP3] = {SPR_ISHR, C, -1, nil, 0, 0, S_NULL}
states[S_ICESHRAP4] = {SPR_ISHR, D, -1, nil, 0, 0, S_NULL}

addHook("MobjThinker", function(spring) if gamemap != 43 return end
	if season == "summer" and spring.state != S_INVISIBLE
		spring.state = S_INVISIBLE
		A_PlayActiveSound(spring)
	end
	
	if spring.state == S_INVISIBLE
		if not spring.SpawnedThem
			spring.flags = MF_NOGRAVITY
			local piece1 = P_SpawnMobj(spring.x, spring.y, spring.z, MT_ICESHRAPNEL)
			local piece2 = P_SpawnMobj(spring.x, spring.y, spring.z, MT_ICESHRAPNEL)
			local piece3 = P_SpawnMobj(spring.x, spring.y, spring.z, MT_ICESHRAPNEL)
			local piece4 = P_SpawnMobj(spring.x, spring.y, spring.z, MT_ICESHRAPNEL)			
			local piece5 = P_SpawnMobj(spring.x, spring.y, spring.z, MT_ICESHRAPNEL)
			local piece6 = P_SpawnMobj(spring.x, spring.y, spring.z, MT_ICESHRAPNEL)
			local piece7 = P_SpawnMobj(spring.x, spring.y, spring.z, MT_ICESHRAPNEL)
			local piece8 = P_SpawnMobj(spring.x, spring.y, spring.z, MT_ICESHRAPNEL)
			piece1.number = 1
			piece2.number = 2
			piece3.number = 3
			piece4.number = 4
			piece5.number = 1
			piece6.number = 2
			piece7.number = 3
			piece8.number = 4
			piece1.angle = spring.angle + (ANG1 * (P_RandomRange(-360, 360)))
			piece2.angle = spring.angle + (ANG1 * (P_RandomRange(-360, 360)))
			piece3.angle = spring.angle + (ANG1 * (P_RandomRange(-360, 360)))
			piece4.angle = spring.angle + (ANG1 * (P_RandomRange(-360, 360)))			
			piece5.angle = spring.angle + (ANG1 * (P_RandomRange(-360, 360)))
			piece6.angle = spring.angle + (ANG1 * (P_RandomRange(-360, 360)))
			piece7.angle = spring.angle + (ANG1 * (P_RandomRange(-360, 360)))
			piece8.angle = spring.angle + (ANG1 * (P_RandomRange(-360, 360)))
			spring.SpawnedThem = true
		end
		
		if spring.respawn
			spring.timerz = $ + 1
			if (spring.timerz > mobjinfo[MT_ICESPRING].painchance*TICRATE)
				spring.Ready = true
				--print("ready")
			end
			
			if spring.Ready and season == "winter"
				spring.state = S_ICESPRING
				spring.flags = spring.DefaultFlags
				spring.timerz = 0
				spring.SpawnedThem = false
				spring.Ready = false
				--print("change back")
			end
		else
			P_RemoveMobj(spring)
		end
	end

end, MT_ICESPRING)

addHook("MapThingSpawn", function(spring, mapthing)	
	spring.timerz = 0 
	
	if mapthing.options & MTF_EXTRA
		spring.respawn = true
		spring.timerz = 0
	end	
	
	if mapthing.options & MTF_AMBUSH
		spring.flags = $1 | MF_NOGRAVITY
	end
	
	spring.DefaultFlags = spring.flags
	
end, MT_ICESPRING)


addHook("MobjThinker", function(pieces) -- this is re-used code from the Rock Shield script. if it ain't broke don't fix it right?
	pieces.shadowscale = FRACUNIT
	
	local function RestoreState()
		if pieces.number == 1
			pieces.state = S_ICESHRAP
		elseif pieces.number == 2
			pieces.state = S_ICESHRAP2	
		elseif pieces.number == 3
			pieces.state = S_ICESHRAP3
		else
			pieces.state = S_ICESHRAP4
		end
	end

	-- [[ remove shrapnel ]] --
	if pieces.timer == nil
		RestoreState()
		pieces.timer = P_RandomRange(0, TICRATE)
		pieces.transstate = 0
		P_SetObjectMomZ(pieces, P_RandomRange(6, 12)*FRACUNIT, false)
		P_InstaThrust(pieces, pieces.angle, -FixedMul((P_RandomRange(5, 35)*FRACUNIT)/12 + FRACUNIT + P_RandomFixed(), pieces.scale))
	end
	
	if not P_IsObjectOnGround(pieces)
		pieces.rollangle = $ + FixedAngle(10<<FRACBITS)
	else
		pieces.rollangle = $ + FixedAngle(4<<FRACBITS)
	end
	
	pieces.timer = $ + 1
		
	if (pieces.timer % 10) == 0
		pieces.transstate = $ + 1
	end
	
	if pieces.transstate == 1
		RestoreState()
		pieces.frame = $1 | TR_TRANS10
	elseif pieces.transstate == 2
		RestoreState()
		pieces.frame = $1 | TR_TRANS20
	elseif pieces.transstate == 3
		RestoreState()
		pieces.frame = $1 | TR_TRANS30
	elseif pieces.transstate == 4
		RestoreState()
		pieces.frame = $1 | TR_TRANS40
	elseif pieces.transstate == 5
		RestoreState()
		pieces.frame = $1 | TR_TRANS50
	elseif pieces.transstate == 6
		RestoreState()
		pieces.frame = $1 | TR_TRANS60
	elseif pieces.transstate == 7
		RestoreState()
		pieces.frame = $1 | TR_TRANS70
	elseif pieces.transstate == 8
		RestoreState()
		pieces.frame = $1 | TR_TRANS80
	elseif pieces.transstate == 9
		RestoreState()
		pieces.frame = $1 | TR_TRANS90
	elseif pieces.transstate >= 10
		P_RemoveMobj(pieces)
		return
	end


end, MT_ICESHRAPNEL)